package main

import (
	"context"
	"gomatrixbot/internal/database"
	f "gomatrixbot/internal/gomatrixbot"
	"log"
	"os"
	"time"

	"github.com/lrstanley/go-ytdlp"
)

func main() {
	// Bootup DB
	db, err := database.InitDb(f.DATABASE_PATH)
	if err != nil {
		log.Fatal(err)
	}
	defer db.CloseDbConn()

	// Set Matrix Credentials
	f.MatrixHost = os.Getenv("MATRIX_HOST")
	f.MatrixUsername = os.Getenv("MATRIX_USERNAME")
	f.MatrixPassword = os.Getenv("MATRIX_PASSWORD")

	// Start application
	f.Run(db)

	// Install tydlp
	ytdlp.MustInstall(context.TODO(), nil)

	// Just keep running
	ch := make(chan bool)
	go func() {
		time.Sleep(time.Minute * 5)
	}()
	<-ch
}
