package gomatrixbot

import (
	"context"
	"fmt"
	"io"
	"math/rand"
	"net/http"
	"os"
	"strings"
	"time"

	"maunium.net/go/mautrix/id"
)

const (
	BASE_PATH     = "/root/data"
	OUTPUT_PATH   = BASE_PATH + "/output"
	THE_GREATS    = BASE_PATH + "/the_greats"
	DATABASE_PATH = BASE_PATH + "/database.sql"
)

func (mtrx *MtrxClient) getFileContent(url string) ([]byte, error) {
	var data []byte
	// Get the data
	resp, err := http.Get(url)
	if err != nil {
		return data, err
	}
	defer resp.Body.Close()

	return io.ReadAll(resp.Body)
}

// saveTheGreat - save an image for late
func (mtrx *MtrxClient) saveTheGreat(ctx context.Context, file string, roomID id.RoomID) {
	b, err := os.ReadFile(file)
	if err != nil {
		mtrx.sendMessage(ctx, roomID, "Failed to read file: "+err.Error())
		return
	}

	err = os.WriteFile(THE_GREATS+fmt.Sprintf("/%d.jpg", time.Now().Unix()), b, 0644)
	if err != nil {
		mtrx.sendMessage(ctx, roomID, "Failed to save file: "+err.Error())
		return
	}

	mtrx.sendMessage(ctx, roomID, "Saved a legendary photo.")
}

func (mtrx *MtrxClient) saveSourcePic(ctx context.Context, file string, roomID id.RoomID) {
	b, err := os.ReadFile(file)
	if err != nil {
		mtrx.sendMessage(ctx, roomID, "Failed to read file: "+err.Error())
		return
	}

	err = os.WriteFile(BIRB_PATH+fmt.Sprintf("/%d.jpg", time.Now().Unix()), b, 0644)
	if err != nil {
		mtrx.sendMessage(ctx, roomID, "Failed to save file: "+err.Error())
		return
	}

	mtrx.sendMessage(ctx, roomID, "🚀 saved!")
}

func (mtrx *MtrxClient) postTheGreats(ctx context.Context, roomID id.RoomID) {
	files, err := os.ReadDir(THE_GREATS)
	if err != nil {
		mtrx.sendMessage(ctx, roomID, "Failed to read the greats: "+err.Error())
		return
	}

	rands := make([]string, 0)
	for _, file := range files {
		if file.IsDir() || strings.HasPrefix(file.Name(), ".") {
			continue
		}

		rands = append(rands, THE_GREATS+"/"+file.Name())
	}

	mtrx.uploadAndPostFile(ctx, roomID, rands[rand.Intn(len(rands))])
}

// contains - Check if value is in list
func contains[s comparable](x []s, e s) bool {
	for _, a := range x {
		if a == e {
			return true
		}
	}
	return false
}
